package example;

import javax.annotation.Resource;
import javax.persistence.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.transaction.NotSupportedException;
import javax.transaction.RollbackException;
import javax.transaction.UserTransaction;

import java.io.*;

public class RegistrationServlet extends BaseServlet {

    public void service (HttpServletRequest req , HttpServletResponse resp)
                    throws ServletException, IOException {

        EntityManager em = createEntityManager(req);

	em.getTransaction().begin();

        try {
            resp.setContentType("text/html");
            PrintWriter out = resp.getWriter();
            out.println("<HTML> <HEAD> <TITLE>New User Registartion " +
                        "</TITLE> </HEAD> <BODY BGCOLOR=white>");

            String name = req.getParameter("name");
            String password = req.getParameter("password");

            UserCredential credential = new UserCredential(name, password);
    
            // em.persist makes the new object as persistent and managed.
            em.persist(credential); 
    
    
            out.println("Successfully created the new user. " +
                            "Click <A HREF=\"login.html\"> here </A> to login.");
            out.println("</BODY> </HTML> ");

            // commit the transaction, 
            // b'cos web container rollbacks unfinished tx at the end of request
            em.getTransaction().commit();
        } catch (Exception e) {
            try {
                em.getTransaction().rollback();
            } catch (Exception ee) {
                // log the exception and continue
            }
            throw new ServletException(e);
        } finally {
            // close the em so that provider can release resources.
            closeEntityManager(req);
        }
    }

    public void  init( ServletConfig config) throws ServletException {
        super.init(config);
    }
    
}
